---
name: Feature Request
about: Help us understand your use case and expand Concourse's functionality
title: ''
labels: enhancement
assignees: ''

---

> Please remove all lines starting with '>' before submitting!
>
> CI systems have a ton of users, so naturally they'll get a ton of feature
> requests. We don't want to just implement all of them, because we want
> Concourse to stay simple.
>
> We use feature requests to capture use cases that Concourse could support
> better. This means the *context* for a request is often more important than
> the suggested feature.
>
> We try to target use cases that we understand the most, and make changes that
> have the widest possible impact so that we satisfy many use cases at once.
> This also means it can take a long time for a feature request to be
> satisfied. To speed this up, check out `CONTRIBUTING.md`:
>
>     https://github.com/concourse/concourse/blob/master/.github/CONTRIBUTING.md

## What challenge are you facing?

> Without jumping to a solution, describe the problem you're facing, and
> provide context. It helps us more to understand your problem first. This way
> we may be able to connect the dots between your issue and others and perhaps
> come up with a more general proposal, rather than tacking on feature after
> feature.

## What would make this better?

> If you've got a suggestion, feel free to place it here! It also helps to
> describe how you arrived at this idea and why it'd work well for you.

## Are you interested in implementing this yourself?

> Let us know! We're happy to help you put together and iterate on a pull
> request.
